#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "estrazione.h"


long *gEl   = NULL; // il vettore dei valori da estrarre
long gMaxEl = 0;    // le dimensioni del vettore gEl
long gQEl   = 0;    // la quantita' dei numeri ancora da estrarre da gEl
long gUE    = -1;   // il valore dell'ultimo numero estratto


int InizializzaEstrazione( long qEl ) {
    long *tmp;

    qEl = qEl>1 ? qEl : (qEl<-1?-qEl:2);
    tmp = calloc( qEl, sizeof(*tmp) );

    if( tmp ) {
        long i;

        for( i=0; i<qEl; ++i )
            tmp[i] = i;

        gEl    = tmp;
        gMaxEl = qEl;
        gQEl   = qEl;
        gUE    = -1;

        srand( time(NULL) );

        return 0;
    }

    return 1;
}

void DismettiEstrazione( void ) {
    if( gEl ) {
        free( gEl );
        gEl    = NULL;
        gMaxEl = 0;
        gQEl   = 0;
        gUE    = -1;
    }
}

long EstraiLong( void ) { // 31 bit
    unsigned long e;

    e = ((unsigned long)rand())<<16;
    e |= ((unsigned long)rand());
    e |= 0x00008000;

    return (long) e;
}

long Estrai( void ) {
    long el = EstraiLong() % gQEl;

    gUE = gEl[el];

    --gQEl;

    if( gQEl > 0 ) {
        while( el < gQEl ) {
            gEl[el] = gEl[el+1];
            ++el;
        }

        gEl[el] = -1;
    }
    else {
        Reimposta();
    }

    return gUE;
}

long UltimoEstratto( void ) {
    return gUE;
}

void Reimposta( void ) {
    long i;

    for( i=0; i<gMaxEl; ++i )
        gEl[i] = i;

    gQEl = gMaxEl;
}
