#include <windows.h>

#include "vocaboli.h"
#include "interfaccia_win32.h"
#include "items.h"
#include "estrazione.h"
#include "risorse.h"


const char kStrNomeProg[] = "Parole";

HINSTANCE gHInst;
HWND gHwnd;


BOOL CALLBACK WPDlg_Parole( HWND hwnd, UINT msg, WPARAM wPar, LPARAM lPar );


int APIENTRY WinMain( HINSTANCE hInst, HINSTANCE hPInst, LPSTR cmd, int show ) {
    int errore;

    gHInst = hInst;

    errore = CaricaVocabolario();

    if( !errore ) {
        errore = InizializzaEstrazione( QVocaboliVocabolario() );

        if( !errore ) {
            errore = DialogBox(
                hInst, MAKEINTRESOURCE(DLG_PAROLE), NULL, (DLGPROC)WPDlg_Parole );
            DismettiEstrazione();
        }

        DismettiVocabolario();
        DismettiVocaboliEstratti();
    }

    return MostraErrore( errore, gHwnd );
}


BOOL CALLBACK WPDlg_Parole( HWND hwnd, UINT msg, WPARAM wPar, LPARAM lPar ) {
    int errore;

    switch( msg ) {
        case WM_INITDIALOG: {
            gHwnd = hwnd;
            SetDlgItemInt( hwnd, IDC_QPAROLE, 0, FALSE );
            SendDlgItemMessage( hwnd, IDC_QPAROLE, EM_SETSEL, 0, -1 );
            SendDlgItemMessage( hwnd, IDC_QPAROLE, EM_LIMITTEXT, 6, 0 );
            SetFocus( GetDlgItem(hwnd,IDC_QPAROLE) );
        } return FALSE;

        case WM_CLOSE:
            gHwnd = NULL;
            EndDialog( hwnd, 0 );
            return TRUE;

        case WM_COMMAND:
            switch( LOWORD(wPar) ) {
                case IDOK: {
                    long qVocaboli = GetDlgItemInt( hwnd, IDC_QPAROLE, NULL, FALSE );

                    errore = EstraiVocaboli( qVocaboli );

                    if( !errore )
                        MostraVocaboli( hwnd, IDC_EPAROLE );
                    else MostraErrore( errore, hwnd );
                    } break;

                case IDCANCEL:
                    SendMessage( hwnd, WM_CLOSE, 0, 0 );
                    break;

                default: ;
            }
            return TRUE;

        default: ;
    }

    return FALSE;
}
